# coding: utf-8

"""
    Slurm Rest API

    API to access and control Slurm.

    The version of the OpenAPI document: 0.0.37
    Contact: sales@schedmd.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from aind_slurm_rest.models.dbv0036_coordinator_info import Dbv0036CoordinatorInfo
from aind_slurm_rest.models.dbv0036_user_associations import Dbv0036UserAssociations
from aind_slurm_rest.models.dbv0037_user_default import Dbv0037UserDefault
from typing import Optional, Set
from typing_extensions import Self

class Dbv0036User(BaseModel):
    """
    User description
    """ # noqa: E501
    administrator_level: Optional[StrictStr] = Field(default=None, description="Description of administrator level")
    associations: Optional[Dbv0036UserAssociations] = None
    coordinators: Optional[List[Dbv0036CoordinatorInfo]] = Field(default=None, description="List of assigned coordinators")
    default: Optional[Dbv0037UserDefault] = None
    name: Optional[StrictStr] = Field(default=None, description="User name")
    __properties: ClassVar[List[str]] = ["administrator_level", "associations", "coordinators", "default", "name"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Dbv0036User from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of associations
        if self.associations:
            _dict['associations'] = self.associations.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in coordinators (list)
        _items = []
        if self.coordinators:
            for _item_coordinators in self.coordinators:
                if _item_coordinators:
                    _items.append(_item_coordinators.to_dict())
            _dict['coordinators'] = _items
        # override the default output from pydantic by calling `to_dict()` of default
        if self.default:
            _dict['default'] = self.default.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Dbv0036User from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "administrator_level": obj.get("administrator_level"),
            "associations": Dbv0036UserAssociations.from_dict(obj["associations"]) if obj.get("associations") is not None else None,
            "coordinators": [Dbv0036CoordinatorInfo.from_dict(_item) for _item in obj["coordinators"]] if obj.get("coordinators") is not None else None,
            "default": Dbv0037UserDefault.from_dict(obj["default"]) if obj.get("default") is not None else None,
            "name": obj.get("name")
        })
        return _obj


